#include <stc8h.h>
#include <intrins.h>
#include <stdio.h>
#include "gpio.h"

typedef     unsigned char   u8;
typedef     unsigned int    u16;
typedef     unsigned long   u32;

/*********************** ʱT0弰   ************************/
u32 cnt1ms = 0;				//1msʱ
void Timer0_Init(void);			//1@18.432MHz

/*********************  1  ledˮƱ弰   *********************/
u8 led = 0xfe;					//led
u16	cnt_led = 0;
void wait_led(void);			//ledˮӺ

/******************  2 ʾ弰   ***********************/
u8 code  LED_SEG[]={0xc0,0xf9,0xa4,0xb0,0x99,0x92,0x82,0xf8,0x80,0x90,0x88,0x83,0xc6, 0xa1,0x86,0x8e,0xff,0x40,0x79,0x24,0x30,0x19,0x12d,0x02,0x78,0x00,0x10,0xbf };  
  //"0123456789""ABCDEF"Լ""
  //"0123456789"С㣩ַԼ-
u8 code  Scan_bit[]={0xfe,0xfd,0xfb,0xf7,0xef,0xdf, 0xbf, 0x7f};   //ɨλ
u8 data  Dis_buf[]={16,16,16,16,16,16,16,16};   //ʾΪ""
u8 id = 0;		//ѭʾ
u16 second = 0;

//
sbit key0 = P3^2;
sbit key1 = P3^3;
u8 key_cnt = 0;
u8 key0_dly = 0,key1_dly = 0;
u8 Key0_Status = 0,Key1_Status = 0;

void DisplayScan(void);

/***********************  4  A/D弰   *************************/
#define OSC	18432000L    		//OSCƵ18432000Hz
#define BAUD	9600        	//BAUD9600
#define URMD	0           	//URMDֵ
float voltage=0;            		//帡ģѹֵ
u8 tstr[5];     					//޷ַ鱣ģѹֵӦַ
//u16 tmp=0;         				//޷ͱtmp
float old_voltage=0;       			//帡old_voltage
#define	ADC_OFFSET	64		//ƫΧ
u8 	ADC_KeyCode=0;				//屣ı
u16 ad_volume=0;					//屣A/Dתı
u8 cnt_ADC_1ms = 0;
u16	i,i1,i2,j;
void	CalculateAdcKey(u16 adc);		//ADC̼뺯
u16	Get_ADC12bitResult(u8 channel);	//ADֵ  channel = 0~7
void SendData(unsigned char);		//ڷͺ
void Uart1_Init(void);

/********************  5  弰   ************************/
sbit BEEP = P5^4;
u8 cnt_BEEP_1ms = 0;

/*******************  IO󰴼弰   ************************/
u8  IO_KeyCode;    							//1~8Ч
u8 IO_KeyState, IO_KeyState1, IO_KeyHoldCnt;   	//м̱
u8 cnt_IO_1ms = 0;
void IO_KeyScan(void);   						//ɨӺ
void IO_KeyDelay(void);

/**********************  7  弰   *************************/
#define User_code   0xFF00    //û
sbit 		P_IR_TX   = P2^7;   //ⷢͶ˿
#define 	IR_TX_ON    0
#define	 IR_TX_OFF   1
u16		tx_cnt;     	//ͻеƵΪ38KHZ, 26.3us
u8      TxTime;     //ʱ
u8		cnt_IR_1ms = 0;

void    PWM_config(void);
void    IR_TxPulse(u16 pulse);
void    IR_TxSpace(u16 pulse);
void    IR_TxByte(u8 dat);


/****************************  **************************************/
void main(void)
{
L2:
	gpio();
	Timer0_Init();		//T0ʼ
	Uart1_Init();		//ô1ʼ
    PWM_config();	//PWMʼ
  	ADCCFG=ADCCFG|0x20;		//A/DתüĴ  RESFMT1 Ҷ
	ADC_CONTR = 0x80;			//ADC_POWER1 A/DתԴ
	
ET0 = 1;    //Timer0 interrupt enable
  	EA = 1;     //ж
  
	P40 = 1;
 	P_IR_TX = IR_TX_OFF;
	cnt1ms = 0;
	P7 = 0xff;
	
	while(1)
 	{
		if(cnt_IO_1ms >= 50)     //50msɨһм
    	{
			cnt_IO_1ms = 0;
      		IO_KeyScan();
    	}
			
		switch(IO_KeyCode)	//󰴼ֵж
		{
			//ˮ
			case 1:	
				BEEP = 1;
				P7 = 0xff;
				P6 = led;
				P40 = 0;
				cnt1ms = 0;
				if(cnt_led >= 500)		//ÿ500ms任
				{
					cnt_led = 0;
					wait_led();		//ˮ
				}
				break;
			//ʱ
			case 2:
				BEEP = 1;
				P40 = 1;
				second = cnt1ms/1000;
				Dis_buf[7]=second%10;        //ֵʾ
				Dis_buf[6]=second/10%10;
				Dis_buf[5]=second/100%10;
				Dis_buf[4]=second/1000%10;
				Dis_buf[3]=second/10000%10;
				Dis_buf[2]=second/100000%10;
				Dis_buf[1]=second/1000000%10;
				Dis_buf[0]=0;				
				break;
			//ɼӿɼ
			case 3:	
				BEEP = 1;
				P40 = 1;
				cnt1ms = 0;
				Dis_buf[7] = key_cnt%10;        //ֵʾ
				Dis_buf[6] = key_cnt/10%10;
				Dis_buf[5] = key_cnt/100%10;
				Dis_buf[4] = 16;
				Dis_buf[3] = 16;
				Dis_buf[2] = 16;
				Dis_buf[1] = 16;
				Dis_buf[0] = 16;
				break;
			//A/Dתand
			case 4:		
				P1M1=P1M1|0x01;		//˿P1ΪΪ루̬ģʽ
				P40 = 1;
				BEEP = 1;
				cnt1ms = 0;
				Dis_buf[7] = ad_volume%10;	   	//ʾadֵ
				Dis_buf[6] = ad_volume/10%10;		//ʾadֵ
				Dis_buf[5] = ad_volume/100%10;		//ʾadֵ
				Dis_buf[4] = ad_volume/1000%10;	//ʾadֵ
				Dis_buf[3] = 16;
				Dis_buf[2] = 16;				
				
				if(cnt_ADC_1ms >= 15)				//15msһADC
				{
					cnt_ADC_1ms = 0;				//
					j = Get_ADC12bitResult(0);		//0ͨѯADC, ֵ
					if(((256-ADC_OFFSET)<j)&&(j < 4096))
					{
						j = Get_ADC12bitResult(0);	//ٴλADC
						if(((256-ADC_OFFSET)<j)&&(j < 4096))
						{ 
							ad_volume=j;			//ADCad_volume
							CalculateAdcKey(j);	//㰴
							Dis_buf[4] = ad_volume/1000%10;	//ʾadֵ
							Dis_buf[5] = ad_volume/100%10;		//ʾadֵ
							Dis_buf[6] = ad_volume/10%10;		//ʾadֵ
							Dis_buf[7] = ad_volume%10;	   	//ʾadֵ
							
							Dis_buf[0] = ADC_KeyCode/10;		//ʾ
							Dis_buf[1] = ADC_KeyCode%10;		//ʾ 
							
							voltage = (j*5.0)/4096;   //õӦĸģѹֵ
							sprintf(tstr,"%1.4f",voltage); //תַ
							if(voltage!=old_voltage)    //µתֵھɵתֵ
							{	
								old_voltage = voltage; 	//תֵתֵ
								for(i=0;i<=5;i++)      //͸ַ
								SendData(tstr[i]);  	//1λ4λС
								SendData('V');        //͵λ												SendData('\r');        //ͻس
								SendData('\n');			//ͻз
							}
		L1:					j = Get_ADC12bitResult(0);	//L1ѭ һֱѯADC
							while(((256-ADC_OFFSET)<j)&&(j < 4096))//ʱ
							{
								goto L1;	
							}
						}	
					}							  
				}
				break;
			//
			case 5:		
				P7 = 0xff;
				P40 = 0;
				P6 = 0x00;
				cnt1ms = 0;
				if(cnt_BEEP_1ms >= 50)
				{
					cnt_BEEP_1ms = 0;
					BEEP = ~BEEP;		//
				}
				break;
			//ʱ
			case 6:
				BEEP = 1;
				P40 = 1;
				second = cnt1ms/1000;
				Dis_buf[7]=(300-second)%10;        //ֵʾ
				Dis_buf[6]=(300-second)/10%10;
				Dis_buf[5]=(300-second)/100%10;
				Dis_buf[4]=16;
				Dis_buf[3]=16;
				Dis_buf[2]=16;
				Dis_buf[1]=16;
				Dis_buf[0]=16;
				break;	
			//ⷢ
case 7:
				BEEP = 1;
				P7 = 0xff;
				P40 = 1;
				P_IR_TX = IR_TX_ON;
				TxTime = 0;
        		IR_TxPulse(342);    //Ӧ9msͬͷ       9ms
       		 	IR_TxSpace(171);    //Ӧ4.5msͬͷ 4.5ms
        		IR_TxPulse(21);     //ʼ          0.5625ms
        		IR_TxByte(User_code%256);   //ûֽ
        		IR_TxByte(User_code/256);   //ûֽ	
				P_IR_TX = IR_TX_OFF;
				break;
			//λ
			case 8:
				BEEP = 1;
				P7 = 0xff;
				P40 = 1;				
				goto L2;
				break;
		}
}
} 


/*************************** 1  ledˮ ***************************/
void wait_led(void)
{
	led =_crol_(led,1); 	//ѭһλƳλٲλ
	P6 = led;
}

/************************** 2 ʾɨ躯 ****************************/
void DisplayScan(void)
{   
	P7 =0xff; 
	P6 =LED_SEG[Dis_buf[id]]; 
	P7 = Scan_bit[7-id]; 
	if(++id==8)id=0;//8λ0
}
/**************************** 4 ADC ***********************************/
//ADֵ
u16	Get_ADC12bitResult(u8 channel)	//Ƶchannel = 0~15 ʵΪ0ͨ
{
	ADC_RES = 0;		//A/DתλĴ
	ADC_RESL = 0;		//A/DתλĴ

//ADCת 
//ADC_CONTR--A/DתģƼĴ		
//ADC_CONTR = 1100 0000 A/DתͬʱѡP1.0ΪA/Dתģźͨ
	ADC_CONTR = (ADC_CONTR & 0xe0) | 0x40 | channel;
	_nop_();  	_nop_(); 	_nop_();	_nop_();				//ʱ
	while((ADC_CONTR & 0x20) == 0)	;		//ȴADCתɣADC_FLAG==1
	ADC_CONTR &= ~0x20;					//ADC־ADC_FLAG=0;
	return	(((u16)ADC_RES << 8) | ADC_RESL );		//ؽ
}
// ADC̼
void	CalculateAdcKey(u16 adc)
{
	u8	i;
	u16	j=256;			//256512768......4096
	for(i=1;i<=16;i++)
	{
		//жƫΧ ѭ¼ֵ
		if((adc >= (j-ADC_OFFSET)) && (adc <= (j + ADC_OFFSET)))	break;				j += 256;
	}
	if(i<17)	ADC_KeyCode = i;	//			
}

/******************************** 4  ********************************/
//1ʼ
void Uart1_Init(void)
{
	SCON=0x5A;               	//1Ϊ8λɱ䲨ģʽ
	T2L=65536-OSC/4/BAUD;    	//дʱ28λĴT2L
	T2H=(65536-OSC/4/BAUD)>>8;	//дʱ28λĴT2H
	AUXR=0x14;                	//ʱ2Ƶʱ2
	AUXR|=0x01;               	//ѡʱ2Ϊ1Ĳʷ
}
//ͺ
void SendData(u8 dat)	//庯SendData
{	
	EA=0;
  	while(!TI);          	//жϷǷûȴ
	TI=0;               	//ͱ־TI
	SBUF=dat;          	//datдĴSBUF
	EA=1;
}

/**********************  Timer0 1msжϺ  ************************/
void timer0 (void) interrupt 1
{
	cnt1ms++;
	cnt_IO_1ms++;
	cnt_led++;
	cnt_BEEP_1ms++;
	cnt_ADC_1ms++;
	cnt_IR_1ms++;
	switch(IO_KeyCode)
	{
		//ʱ
		case 2:		
			DisplayScan();			//ʾ
			break;
		//ɼӿɼ
		case 3:
			DisplayScan();			//ʾ
			switch (Key0_Status)	//SW17״̬ж
			{
				case 0: 			//0״̬
					if(key0==0) Key0_Status=1;	//⵽key0==0״̬1
					break;			//switch
				case 1: 				//1״̬
					key0_dly++; 		//״̬=1ʱÿһT0жϣʱ+1
					if (key0_dly==10)		//ʱ10ms
					{
						key0_dly=0;		//ʱ
						if(key0==0) Key0_Status=2;	//ʱkey0ȻΪ£״̬2
					}		
					break;				//switch
				case 2: 					//2״̬
					if (key0==0) 			//key0Ȼ£жϰȶ
					{
						key_cnt++;
						Key0_Status=3;	//ִ󽫰״̬3Key0_Status=3
					}
					break;				//switch
				case 3:					//3״̬
					if(key0==1) Key0_Status=0;		//⵽̧𣬰״̬0
			}
			
			switch (Key1_Status)			//SW18״̬ж
			{
				case 0: 					//0״̬
					if(key1==0) Key1_Status=1;		//⵽£״̬1
					break;				//switch
				case 1: 					//1״̬
					key1_dly++; 			//״̬=1ʱÿһT0жϣʱ+1
					if (key1_dly==10)		//ʱ10ms
					{
						key1_dly=0;		//ʱ
						if(key1==0) Key1_Status=2;	//ʱkey1Ȼ£״̬2
					}		
					break;				//switch
				case 2: 					//2״̬
					if (key1==0) 			//ʱkey1԰£жϰȶ
					{
						key_cnt--;
						Key1_Status=3;	//ִһκ󽫰״̬3
					}
					break;				//switch
				case 3:					//3״̬
					if(key1==1)	Key1_Status=0;	//⵽̧𣬰״̬0
					break;				//switch
			}
			break;
		//A/Dתand
		case 4:
			DisplayScan();			//ʾ			
			break;
		//ʱ
		case 6:		
			DisplayScan();			//ʾ
			break;
	}
}

/**************** T0ʱʼ ******************/
void Timer0_Init(void)		//1@18.432MHz
{
	AUXR |= 0x80;			//ʱʱ1Tģʽ
	TMOD &= 0xF0;			//öʱģʽ
//	TL0 = 0x00;				//öʱʼֵ
//	TH0 = 0xB8;				//öʱʼֵ
	TL0 = 0xCD;				//öʱʼֵ
	TH0 = 0xF8;				//öʱʼֵ
	TF0 = 0;				//TF0־
	TR0 = 1;				//ʱ0ʼʱ
}

/*****************************************************
    мɨ
    ʹXY4x4ķֻܵٶȿ
   Y     P04      P05      P06      P07
          |        |        |        |
X         |        |        |        |
P00 ---- K00 ---- K01 ---- K02 ---- K03 ----
          |        |        |        |
P01 ---- K04 ---- K05 ---- K06 ---- K07 ----
          |        |        |        |
P02 ---- K08 ---- K09 ---- K10 ---- K11 ----
          |        |        |        |
P03 ---- K12 ---- K13 ---- K14 ---- K15 ----
          |        |        |        |
******************************************************/

u8 code T_KeyTable[16] = {0,1,2,0,3,0,0,0,4,0,0,0,0,0,0,0};

void IO_KeyDelay(void)
{
    u8 i;
    i = 60;
    while(--i)  ;
}

void IO_KeyScan(void)    //50ms call
{
    u8  j;

    j = IO_KeyState1;   //һ״̬

    P0 = 0xf0;  		//XͣY
    IO_KeyDelay();
    IO_KeyState1 = P0 & 0xf0;
    P0 = 0x0f;  		//YͣX
    IO_KeyDelay();
    IO_KeyState1 |= (P0 & 0x0f);
    IO_KeyState1 ^= 0xff;   //ȡ
    if(j == IO_KeyState1)   //ζ
    {
        j = IO_KeyState;
        IO_KeyState = IO_KeyState1;
        if(IO_KeyState != 0)    	//м
        {
            F0 = 0;
            if(j == 0)  F0 = 1;	 	//һΰ
            else if(j == IO_KeyState)
            {
                if(++IO_KeyHoldCnt >= 20)   //1ؼ
                {
                    IO_KeyHoldCnt = 18;
                    F0 = 1;
                }
            }
            if(F0)
            {
                j = T_KeyTable[IO_KeyState >> 4];
                if((j != 0) && (T_KeyTable[IO_KeyState& 0x0f] != 0)) 
       			{	
IO_KeyCode = (j - 1) * 4 + T_KeyTable[IO_KeyState & 0x0f] - 8;    
//룬1~8
}
            }
        }
        else    IO_KeyHoldCnt = 0;
    }
    P0 = 0xff;
}

/*******************************  7  *********************************/
//庯
void IR_TxPulse(u16 pulse)
{
    tx_cnt = pulse;
    PWMA_CCER2 = 0x00;	 //д CCMRx ǰ CCxE رͨ
    PWMA_CCMR4 = 0x68; 	// PWM4 ģʽ1 
    PWMA_CCER2 = 0x70; 	//ʹ CC4NE ͨ, ͵ƽЧ
    PWMA_IER = 0x10;   	//ʹܲ/Ƚ 4 ж
    while(tx_cnt);
}

//Ϳк
void IR_TxSpace(u16 pulse)
{
    tx_cnt = pulse;
    PWMA_CCER2 = 0x00; 	//д CCMRx ǰ CCxE رͨ
    PWMA_CCMR4 = 0x40; 	// PWM4 ǿΪЧƽ
    PWMA_CCER2 = 0x70; 	//ʹ CC4NE ͨ, ͵ƽЧ
    PWMA_IER = 0x10;   	//ʹܲ/Ƚ 4 ж
    while(tx_cnt);
}

//һֽں
void IR_TxByte(u8 dat)
{
    u8 i;
    for(i=0; i<8; i++)
    {
        if(dat & 1)   	IR_TxSpace(63);    //1Ӧ 1.6875 + 0.5625 ms 
        else         IR_TxSpace(21);    //0Ӧ 0.5625 + 0.5625 ms
        IR_TxPulse(21);         //嶼0.5625ms
        dat >>= 1;              //һλ
    }
}

/*********************************  PWM  ********************************/
void PWM_config(void)
{
    PWMA_CCER2 = 0x00; //д CCMRx ǰ CCxE رͨ
    PWMA_CCMR4 = 0x68; // PWM4 ģʽ1 
    PWMA_ARRH = 0x02; //ʱ
    PWMA_ARRL = 0x77;
    PWMA_CCR4H = 0;
    PWMA_CCR4L = 210; //ռձʱ

    PWMA_PS = 0x40;  //4N ѡλ, 0x00:P1.7, 0x40:P2.7, 0x80:P6.7, 0xC0:P3.3
//  PWMA_PS = 0x40;  // 4P ѡλ, 0x00:P1.6, 0x40:P2.6, 0x80:P6.6, 0xC0:P3.4
    PWMA_ENO = 0x80; //ʹ PWM4N 
//  PWMA_ENO = 0x40; //ʹ PWM4P 
    PWMA_BKR = 0x80; //ʹ
//    PWMA_IER = 0x10; // ʹж
    PWMA_CR1 |= 0x01; //ʼʱ
}

/******************* PWMжϺ ********************/
void PWMA_ISR() interrupt 26
{
    if(PWMA_SR1 & 0X10)
    {
        //PWMA_SR1 &=~0X10;
        PWMA_SR1 = 0;
        if(--tx_cnt == 0)
        {
            PWMA_CCER2 = 0x00; //д CCMRx ǰ CCxE رͨ
            PWMA_CCMR4 = 0x40; // PWM4 ǿΪЧƽ
            PWMA_CCER2 = 0x70; //ʹ CC4NE ͨ, ͵ƽЧ
            PWMA_IER = 0x00;   // رж
        }
	}
}